*=$1000

        sei

        lda #%00100000
v1      bit $e840
        beq v1          ; wait until out of vblank (branch if bit not set)
        ldy #00

loop    ldx #$ff        ; set timer to 65535
        stx $e848       ; load low-byte in timer
        lda #%00100000
v2      bit $e840
        bne v2          ; wait until in vblank (branch if bit set)
        stx $e849       ; load high-byte in timer and start timer
        lda #%00100000
v3      bit $e840
        beq v3          ; wait until out of vblank (branch if bit not set)
        ldx $e849
        lda $e848       
        clc
        adc #$04
        sta $1800,y
        txa
        sta $1900,y     ; write timer values to table
        dey
        bne loop        ; repeat for 255 more times


        lda #%00100000
v4      bit $e840
        bne v4          ; wait until in vblank (branch if bit set)
        ldy #00

loop2   ldx #$ff        ; set timer to 65535
        stx $e848
        lda #%00100000
v5      bit $e840
        beq v5          ; wait until out of vblank (branch if bit not set)
        stx $e849       ; load high-byte in timer and start timer
        lda #%00100000
v6      bit $e840
        bne v6          ; wait until in vblank (branch if bit set)
        ldx $e849
        lda $e848       
        clc
        adc #$04
        sta $1a00,y
        txa
        sta $1b00,y     ; write timer values to table
        dey
        bne loop2       ; repeat for 255 more times

        cli
        rts
